sub SUM {
    local($sum) = pop(@_);
    foreach $foo (@_) {
	$sum += $foo;
    }
    $sum;
}

sub MAX {
    local($max) = pop(@_);
    foreach $foo (@_) {
	$max = $foo if $max < $foo;
    }
    $max;
}

sub MIN {
    local($min) = pop(@_);
    foreach $foo (@_) {
	$min = $foo if $min > $foo;
    }
    $min;
}

sub KEYSBYVALUE {
    local(%passed_aa) = @_;
    sub by_val {
       -($passed_aa{$a} <=> $passed_aa{$b});
    }
@sorted_keys = sort by_val keys(%passed_aa);
}

sub SGN {
    local($num) = @_[0];
    ($num < 0) ? -1 : ($num > 0);
}

sub ABS {
    local($num) = @_[0];
    ($num < 0) ? -$num : $num;
}

sub MARKOV {
    local(@series) = @_;
    local($index);
    local(@sgn_series, @result);
    foreach $index (1..$#series) {
	push(@sgn_series, &SGN($series[$index] - $series[$index-1]));
    }
    @result 
	= (&SERIAL_CORR(@series), &SERIAL_CORR(@sgn_series));
    @result;
}

sub SERIAL_CORR {
    local(@series) = @_;
    local($n) = scalar(@series);
    local ($corr) = 0;
    if ($n > 2)
    {
	$n = $n-1;
	local($index, $sumx, $sumy, $sumxx, $sumyy, $sumxy);
	local($meanx, $stdx, $meany, $stdx, $meanxy);
	foreach $index (1..$#series)
	{
	    $x = $series[$index];
	    $y = $series[$index-1];
	    $sumx += $x; $sumy += $y;
	    $sumxx += $x**2; $sumyy += $y**2;
	    $sumxy += $x*$y;
	}
	$meanx = $sumx/$n; $meany = $sumy/$n; $meanxy = $sumxy/$n;	
	$stdx = sqrt(&ABS($sumxx/$n - $meanx**2));
	$stdy = sqrt(&ABS($sumyy/$n - $meany**2));
	$corr = ($meanxy - $meanx*$meany)/($stdx*$stdy) if ($stdx && $stdy);
    }
    $corr;
}

sub SORT_ARRAYS_BY_FIRST {
    local(@array_ref) = @_;
    local(%aa_for_first_array);
    local($nth_val) = 0;
    foreach $array_val (@{$array_ref[0]}) {
	$aa_for_first_array{$nth_val} = $array_val;
	$nth_val++;
    }

    local(@keys_by_value) = &KEYSBYVALUE(%aa_for_first_array);
    local(@array_copy);
    
    foreach $array_ref (@array_ref) {
	@array_copy = @{$array_ref};
	foreach $nth_val (0..$#array_copy) {
	    $$array_ref[$nth_val] = $array_copy[$keys_by_value[$nth_val]];
	}
    }
}
